# SoTexture3 Class Reference
[Nodes]

`#include <Inventor/nodes/SoTexture3.h>`

Inheritance diagram for SoTexture3:

List of all members.

## Detailed Description

The SoTexture3 class is used to map a 3D texture onto geometry.

Shape nodes within the scope of SoTexture3 nodes in the scenegraph (ie below the same SoSeparator and to the righthand side of the SoTexture3) will have the texture applied according to each shape type's individual characteristics. See the documentation of the various shape types (SoFaceSet, SoCube, SoSphere, etc etc) for information about the specifics of how the textures will be applied. An SoTexture3 node will override any previous encountered SoTexture2 nodes and vice versa. Mixing of SoTexture3 and SoTextureCoordinate2 (or the other way around) is legal, but the third texture coordinate component will be ignored (set to 0.0).

Be aware that this class is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since:
  Coin 2.0

  TGS Inventor 2.6

## Public Types

enum | Model { MODULATE = SoTextureImageElement::MODULATE, DECAL = SoTextureImageElement::DECAL, BLEND = SoTextureImageElement::BLEND }
enum | Wrap { REPEAT = SoTextureImageElement::REPEAT, CLAMP = SoTextureImageElement::CLAMP }

## Public Member Functions

| SoTexture3 (void)
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoMFString | filenames
SoSFImage3 | images
SoSFEnum | wrapR
SoSFEnum | wrapS
SoSFEnum | wrapT
SoSFEnum | model
SoSFColor | blendColor

## Protected Member Functions

virtual | ~SoTexture3 ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
virtual void | notify (SoNotList *list)
int | getReadStatus (void)
void | setReadStatus (int s)

## Member Enumeration Documentation

enum SoTexture3::Model

Texture mapping model.

Enumeration values:

  MODULATE | Texture image is modulated with polygon.
  DECAL | Texture image overwrites polygon color.
  BLEND | Blend image using blendColor.

enum SoTexture3::Wrap

Enum used to specify wrapping strategy.

Enumeration values:

  REPEAT | Repeat texture when coordinate is not between 0 and 1.
  CLAMP | Clamp coordinate between 0 and 1.

## Constructor & Destructor Documentation

SoTexture3::SoTexture3 | ( | void |  | ) |

| Constructor.

SoTexture3::~SoTexture3 | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoTexture3::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoNode.

void SoTexture3::doAction | ( | SoAction * | action | ) | `[virtual]`

| This function performs the typical operation of a node for any action. Reimplemented from SoNode.

void SoTexture3::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoNode.

void SoTexture3::callback | ( | SoCallbackAction * | action | ) | `[virtual]`

| Action method for SoCallbackAction. Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph. Reimplemented from SoNode.

SbBool SoTexture3::readInstance | ( | SoInput * | in,
|  | unsigned short | flags
| ) | `[protected, virtual]`

This method is mainly intended for internal use during file import operations.

It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistant representation of an instance of this class type.

`TRUE` or `FALSE` is returned, depending on if the instantiation and configuration of the new object of this class type went ok or not. The import process should be robust and handle corrupted input streams by returning `FALSE`.

flags is used internally during binary import when reading user extension nodes, group nodes or engines.

Reimplemented from SoNode.

void SoTexture3::notify | ( | SoNotList * | l | ) | `[protected, virtual]`

| Notifies all auditors for this instance when changes are made. Reimplemented from SoNode.

int SoTexture3::getReadStatus | ( | void |  | ) | `[protected]`

| Returns read status. 1 for success, 0 for failure.

void SoTexture3::setReadStatus | ( | int | s | ) | `[protected]`

Sets read status.

See also:
  getReadStatus()

## Member Data Documentation

SoMFString SoTexture3::filenames

Texture filename(s). Specify either this or use SoTexture3::images, not both. The depth of the volume is specifies by the number of filenames specified. All images must have the same dimensions and number of components. NB! A field sensor is attached to this field internally and reloads all images when this field changes. You must therefore be careful when setting this field and either use startEditing()/finishEditing() or set all values with one function call; setValues().

SoSFImage3 SoTexture3::images

| Inline image data.

SoSFEnum SoTexture3::wrapR

| Wrapping strategy for the R coordinate (depth).

SoSFEnum SoTexture3::wrapS

| Wrapping strategy for the S coordinate.

SoSFEnum SoTexture3::wrapT

| Wrapping strategy for the T coordinate.

SoSFEnum SoTexture3::model

| Texture model.

SoSFColor SoTexture3::blendColor

| Blend color. Used when SoTexture3::model is SoTexture3::BLEND.

The documentation for this class was generated from the following files:

- SoTexture3.h
- SoTexture3.cpp